/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.device.controller;

import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.device.dto.IotDeviceHeartbeatDTO;
import org.springblade.device.vo.IotHeartBeatBasicVO;
import org.springblade.device.vo.IotHeartBeatEchartVO;
import org.springblade.third.iotdevice.entity.SingleHeartBeat;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.device.entity.IotDeviceHeartbeat;
import org.springblade.device.vo.IotDeviceHeartbeatVO;
import org.springblade.device.wrapper.IotDeviceHeartbeatWrapper;
import org.springblade.device.service.IIotDeviceHeartbeatService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.*;

/**
 * 设备告警 控制器
 *
 * @author BladeX
 * @since 2021-05-27
 */
@RestController
@AllArgsConstructor
@RequestMapping("/iotdeviceheartbeat")
@Api(value = "设备告警", tags = "设备告警接口")
public class IotDeviceHeartbeatController extends BladeController {

	private final IIotDeviceHeartbeatService iotDeviceHeartbeatService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入iotDeviceHeartbeat")
	public R<IotDeviceHeartbeatVO> detail(IotDeviceHeartbeat iotDeviceHeartbeat) {
		IotDeviceHeartbeat detail = iotDeviceHeartbeatService.getOne(Condition.getQueryWrapper(iotDeviceHeartbeat));
		return R.data(IotDeviceHeartbeatWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 设备告警
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入iotDeviceHeartbeat")
	public R<IPage<IotDeviceHeartbeatVO>> list(IotDeviceHeartbeat iotDeviceHeartbeat, Query query) {
		IPage<IotDeviceHeartbeat> pages = iotDeviceHeartbeatService.page(Condition.getPage(query), Condition.getQueryWrapper(iotDeviceHeartbeat));
		return R.data(IotDeviceHeartbeatWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 设备告警
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入iotDeviceHeartbeat")
	public R<IPage<IotDeviceHeartbeatVO>> page(IotDeviceHeartbeatVO iotDeviceHeartbeat, Query query) {
		IPage<IotDeviceHeartbeatVO> pages = iotDeviceHeartbeatService.selectIotDeviceHeartbeatPage(Condition.getPage(query), iotDeviceHeartbeat);
		return R.data(pages);
	}

	/**
	 * 新增 设备告警
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入iotDeviceHeartbeat")
	public R save(@Valid @RequestBody IotDeviceHeartbeat iotDeviceHeartbeat) {
		return R.status(iotDeviceHeartbeatService.save(iotDeviceHeartbeat));
	}

	/**
	 * 修改 设备告警
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入iotDeviceHeartbeat")
	public R update(@Valid @RequestBody IotDeviceHeartbeat iotDeviceHeartbeat) {
		return R.status(iotDeviceHeartbeatService.updateById(iotDeviceHeartbeat));
	}

	/**
	 * 新增或修改 设备告警
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入iotDeviceHeartbeat")
	public R submit(@Valid @RequestBody IotDeviceHeartbeat iotDeviceHeartbeat) {
		return R.status(iotDeviceHeartbeatService.saveOrUpdate(iotDeviceHeartbeat));
	}


	/**
	 * 删除 设备告警
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(iotDeviceHeartbeatService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 通过DeviceId获取设备心跳数据
	 */
	@GetMapping("/getHeartBeatByDeviceId")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "通过DeviceId获取设备心跳数据", notes = "传入iotDeviceHeartbeat")
	public R getHeartBeatByDeviceId(IotDeviceHeartbeatDTO iotDeviceHeartbeatDTO) {
		List<IotDeviceHeartbeat> heartbeatList = this.iotDeviceHeartbeatService.getHeartBeatByDeviceId(iotDeviceHeartbeatDTO);

		Map<String, IotHeartBeatBasicVO> metricMap = new HashMap<>();
		for (int i = 0;i<heartbeatList.size();i++){
			List<SingleHeartBeat> singleHeartBeats = JSONObject.parseArray(heartbeatList.get(i).getData(), SingleHeartBeat.class);
			for(int j=0;j<singleHeartBeats.size();j++){
				String metric = singleHeartBeats.get(j).getLabel();
				String value = singleHeartBeats.get(j).getValue();
				IotHeartBeatBasicVO basicVO;
				if(metric == null){
					continue;
				}
				if(metricMap.containsKey(metric)){
					basicVO = metricMap.get(metric);
				}else{
					basicVO = new IotHeartBeatBasicVO();
				}
				basicVO.getDataList().add(value);
				basicVO.getDateTimeList().add(heartbeatList.get(i).getCreateTime());
				metricMap.put(metric,basicVO);
			}
		}
		List<IotHeartBeatEchartVO> resultVO = new ArrayList<>();
		for(String metric : metricMap.keySet()){
			IotHeartBeatEchartVO iotHeartBeatEchartVO = new IotHeartBeatEchartVO();
			iotHeartBeatEchartVO.setTag(metric);
			iotHeartBeatEchartVO.setDataList(metricMap.get(metric).getDataList());
			iotHeartBeatEchartVO.setDateTimeList(metricMap.get(metric).getDateTimeList());
			resultVO.add(iotHeartBeatEchartVO);
		}
		return R.data(resultVO);
	}


}
